apiVersion: unfurl/v1alpha1

kind: Ensemble

spec:

  deployment_blueprints:

    gcp:

      title: Google Cloud Platform - Compute Engine

      cloud: unfurl.relationships.ConnectsTo.GoogleCloudProject

      description: Deploy using Google Compute Engine

      resource_templates: 

        dockerhost:

          type: unfurl.nodes.DockerComputeHost

        mariadb-dockerhost:

          type: unfurl.nodes.DockerComputeHost

        the_app:

          type: Diaspora

          properties:

            diaspora_database_host: "mariadb"

            diaspora_database_port_number: "3306"

            diaspora_database_name: "bitnami_diaspora"

            diaspora_database_user: "bn_diaspora"

            diaspora_database_password: "pa55word"



    aws:

      title: Amazon Web Services - EC2

      cloud: unfurl.relationships.ConnectsTo.AWSAccount

      description: Deploy using Amazon Elastic Compute Cloud (EC2)

      resource_templates:

        dockerhost:

          type: unfurl.nodes.DockerComputeHost

    selfhosted:

      title: Local Development

      cloud:

      description: Deploy onto your own development machines.

      resource_templates:

        dockerhost:

          type: unfurl.nodes.LocalDockerHost

        mariadb-dockerhost:

          type: unfurl.nodes.LocalDockerHost

        localdb:

          type: MariaDBInstance

        the_app:

          type: Diaspora

          requirements:

          - db: localdb

          properties:

            diaspora_database_host: "mariadb"

            diaspora_database_port_number: "3306"

            diaspora_database_name: "bitnami_diaspora"

            diaspora_database_user: "bn_diaspora"

            diaspora_database_password: "pa55word"





  service_template:

    description:

    metadata:

      template_name: Diaspora

      template_author:

      template_version: 0.1

      livePreview: #url to a live preview

      image: # url to image

      sourceCodeUrl: # url to the source code repository

      deployments: 0

      webUrl: # url to the source project



    repositories:

      types:

        url: https://gitlab.com/onecommons/unfurl-types



    imports:

      - file: service-template.yaml

        repository: types



    node_types:

      Diaspora:

        derived_from: unfurl.nodes.SQLWebApp

        requirements:

          - db: MySQLDB

          - container: 

             node: container_service          

        properties: 

          diaspora_database_host: 

            type: string

            required: true

            metadata:

              computed: true

          diaspora_database_port_number: 

            type: string

            required: true

            metadata:

              computed: true

          diaspora_database_name: 

            type: string

            required: true

            metadata:

              computed: true

          diaspora_database_user: 

            type: string

            required: true

            metadata:

              computed: true

          diaspora_database_password: 

            type: string

            required: true

            metadata:

              computed: true

        interfaces:

          Mock:

            operations:

              configure:

                implementation: Template

                inputs:

                  dryrun: true

                  resultTemplate:

                    attributes:

                      url: https://ghost-demo.opencloudservices.dev



    topology_template:

      substitution_mappings:

          node: the_app



      node_templates: 

        dockerhost: 

                type: unfurl.nodes.LocalDockerHost

        the_app:

          type: Diaspora

          properties:

            diaspora_database_host: "mariadb"

            diaspora_database_port_number: "3306"

            diaspora_database_name: "bitnami_diaspora"

            diaspora_database_user: "bn_diaspora"

            diaspora_database_password: "pa55word"



        container_service:

          type: unfurl.nodes.ContainerService

          properties:

            container:

              image:  koehn/diaspora:latest

              ports:

                - 3000:3000 # bind the diaspora port

              environment:

                DIASPORA_DATABASE_PASSWORD:

                  eval: .configured_by::diaspora_database_password

                DIASPORA_DATABASE_HOST:

                   eval: .configured_by::diaspora_database_host

                DIASPORA_DATABASE_PORT_NUMBER:

                   eval: .configured_by::diaspora_database_port_number

                DIASPORA_DATABASE_NAME:

                   eval: .configured_by::diaspora_database_name

                DIASPORA_DATABASE_USER:

                    eval: .configured_by::diaspora_database_user

          requirements:

            - host:

                # dockerhost is defined in deployment blueprint

                node: dockerhost









